%errorA = forceRequiredAddOn("Vehicle_Jeep"); //For *ImpactSound
%errorB = forceRequiredAddOn("Vehicle_Tank"); //For tankShellProjectile
%errorC = forceRequiredAddOn("Vehicle_Pirate_Cannon"); //For cannonFuseImage

if(%errorA == $Error::AddOn_Disabled)
	jeepVehicle.uiName = "";
if(%errorB == $Error::AddOn_Disabled) {
	tankTurretPlayer.uiName = "";
	TankVehicle.uiName = "";
	//We could remove the uiName of some emitters and stuff too, but why bother.
}
if(%errorC == $Error::AddOn_Disabled) {
	cannonTurret.uiName = "";
	cannonBallProjectile.uiName = "";
	//We could remove emitters and stuff here too, but again, why bother.
}

if(%errorA == $Error::AddOn_NotFound) {
	error("ERROR: Weapon_OldFashionBomb - required add-on Vehicle_Jeep not found");
	%error = true;
}
if(%errorB == $Error::AddOn_NotFound) {
	error("ERROR: Weapon_OldFashionBomb - required add-on Vehicle_Tank not found");
	%error = true;
}
if(%errorC == $Error::AddOn_NotFound) {
	error("ERROR: Weapon_OldFashionBomb - required add-on Vehicle_PirateCannon not found");
	%error = true;
}
if(%error)
	return;

datablock itemData(oldFashionBombItem) {
	category = "Weapon";
	classname = "Weapon";
	shapeFile = "./bombImage.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.4;
	friction = 0.6;
	emap = true;
	uiName = "Old Fashion Bomb";
	iconName = "./Icon_Bomb";
	image = oldFashionBombImage;
	canDrop = true;
};

datablock shapeBaseImageData(oldFashionBombImage) {
	className = "weaponImage";
	shapeFile = "./bombImage.dts";
	emap = true;
	mountPoint = 0;
	offset = "-0.52 0.3 0";
	item = oldFashionBombItem;

	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0.1;
	stateTransitionOnTimeout[0] = "Ready";
	stateSequence[0] = "ready";
	stateSound[0] = weaponSwitchSound;
	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1] = true;
	stateName[5] = "Fire";
	stateTransitionOnTimeout[5] = "Ready";
	stateTimeoutValue[5] = 0.5;
	stateSequence[5] = "fire";
	stateScript[5] = "onFire";
	stateWaitForTimeout[5] = true;
	stateAllowImageChange[5] = false;
};

datablock shapeBaseImageData(oldFashionBombFuseImage : cannonFuseImage) {
	offset = "-0.217 -0.149 0.93";
	rotation = eulerToMatrix("0 0 0");

	stateTimeoutValue[1] = 0.8;
	stateEmitterTime[1] = 0.8;

	stateTimeoutValue[2] = 1.5;
	stateEmitterTime[2] = 1.5;

	stateTimeoutValue[3] = 3;
	stateEmitterTime[3] = 3;
};

datablock wheeledVehicleData(oldFashionBombVehicle) {
	shapeFile = "./bomb.dts";
	maxDamage = 100;
	destroyedLevel = 100;
	doColorShift = false;
	massCenter = "0 0 -0.2"; //rest upright
	integration = 4;
	collisionTol = 0.1;
	contactTol = 0.1;
	useEyePoint = false;
	numWheels = 0;
	mass = 800;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;
	softImpactSpeed = 10;
	hardImpactSpeed = 15;
	groundImpactMinSpeed = 10.0;
	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	mediumSplashSoundVelocity = 10.0;
	hardSplashSoundVelocity = 20.0;
	exitSplashSoundVelocity = 5.0;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	uiName = "";
	rideable = false;
	lookUpLimit = 0.65;
	lookDownLimit = 0.45;
	finalExplosionProjectile = oldFashionBombFinalExplosionProjectile;
	rideable = false;
	numMountPoints = 1;
	mountThread[0] = "sit";
	mountThread[1] = "sit";

	explodeOnFuseDone = true;
};

addDamageType("oldFashionBomb", '<bitmap:base/client/ui/CI/bomb> %1', '%2 <bitmap:base/client/ui/CI/bomb> %1', 1, 0);
datablock projectileData(oldFashionBombFinalExplosionProjectile : tankShellProjectile) {
	projectileShapeName = "";
	directDamage = 0;
	directDamageType = "";
	radiusDamageType = $DamageType::oldFashionBomb;
	sound = "";
	armingDelay = 0;
	lifetime = 0;
	isBallistic = true;
	hasLight = false;
	explodeOnDeath = true;
	uiName = "";
};

function oldFashionBombImage::onMount(%this, %obj, %slot) {
	parent::onMount(%this, %obj, %slot);
	%obj.playThread(1, armReadyBoth);
}

function oldFashionBombImage::onUnMount(%this, %obj, %slot) {
	parent::onMount(%this, %obj, %slot);
	%obj.playThread(1, root);
}

function oldFashionBombImage::onfire(%this, %obj, %slot) {
	%obj.playThread(2, shiftUp);
	messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, %obj.tool[%obj.currTool] = 0);
	%obj.unMountImage(0);
	%bomb = new wheeledVehicle(oldFashionBomb) {
		dataBlock = "oldFashionBombVehicle";
		owner = %obj.client;
	};
	missionCleanup.add(%bomb);
	%bomb.setTransform(vectorAdd(vectorscale(%obj.getForwardVector(), 1.5), vectorAdd(%obj.getPosition(), "0 0 1.6")) SPC getWords(%obj.getTransform(), 3, 6));
	%bomb.setVelocity(vectorAdd(vectorAdd(vectorscale(%obj.getForwardVector(), 3), %obj.getVelocity()), vectorScale(%obj.getUpVector(), 3)));
	%bomb.mountImage(oldFashionBombFuseImage, 1);
}

function oldFashionBombFuseImage::onDone(%this, %obj, %slot) {
	if(%obj.getDataBlock().explodeOnFuseDone)
		%obj.damage(isObject(%obj.owner.player) ? %obj.owner.player : 0, %obj.getworldboxcenter(), %obj.getDataBlock().maxDamage);
}
